var __create = Object.create;
var __defProp = Object.defineProperty;
var __getProtoOf = Object.getPrototypeOf;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropSymbols = Object.getOwnPropertySymbols;
var __propIsEnum = Object.prototype.propertyIsEnumerable;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, {enumerable: true, configurable: true, writable: true, value}) : obj[key] = value;
var __objSpread = (a, b) => {
  for (var prop in b || (b = {}))
    if (__hasOwnProp.call(b, prop))
      __defNormalProp(a, prop, b[prop]);
  if (__getOwnPropSymbols)
    for (var prop of __getOwnPropSymbols(b)) {
      if (__propIsEnum.call(b, prop))
        __defNormalProp(a, prop, b[prop]);
    }
  return a;
};
var __markAsModule = (target) => __defProp(target, "__esModule", {value: true});
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, {get: all[name], enumerable: true});
};
var __reExport = (target, module2, desc) => {
  if (module2 && typeof module2 === "object" || typeof module2 === "function") {
    for (let key of __getOwnPropNames(module2))
      if (!__hasOwnProp.call(target, key) && key !== "default")
        __defProp(target, key, {get: () => module2[key], enumerable: !(desc = __getOwnPropDesc(module2, key)) || desc.enumerable});
  }
  return target;
};
var __toModule = (module2) => {
  return __reExport(__markAsModule(__defProp(module2 != null ? __create(__getProtoOf(module2)) : {}, "default", module2 && module2.__esModule && "default" in module2 ? {get: () => module2.default, enumerable: true} : {value: module2, enumerable: true})), module2);
};

// src/index.ts
__markAsModule(exports);
__export(exports, {
  default: () => src_default
});

// src/handle/attributes.ts
var Attribute = class {
  constructor(name, value) {
    if (name)
      this.name = name;
    if (value !== void 0)
      this.value = value;
    if (value === null || typeof value !== "object")
      this.invariant = true;
  }
  get expression() {
    return toExpression(this.value);
  }
};
var Prop = class extends Attribute {
};
var ExplicitStyle = class extends Attribute {
  constructor(name, value, important = false) {
    super(name, Array.isArray(value) ? flatten(value) : value);
    this.important = important;
  }
};
var flatten = (content) => {
  const [callee, ...args] = content;
  return `${callee}(${args.join(" ")})`;
};

// src/syntax.ts
var syntax_exports = {};
__export(syntax_exports, {
  BabelProgram: () => import_types.Program,
  call: () => call,
  declare: () => declare,
  get: () => get,
  isBinaryAssertion: () => isBinaryAssertion,
  object: () => object,
  objectAssign: () => objectAssign,
  objectKeys: () => objectKeys,
  require: () => require2,
  template: () => template
});
var t = __toModule(require("@babel/types"));
var import_types = __toModule(require("@babel/types"));
__reExport(syntax_exports, __toModule(require("@babel/types")));
function object(obj = {}) {
  const properties = [];
  for (const x in obj)
    if (obj[x])
      properties.push(t.objectProperty(t.identifier(x), obj[x]));
  return t.objectExpression(properties);
}
function get(object2, ...path) {
  if (object2 == "this")
    object2 = t.thisExpression();
  if (typeof object2 == "string")
    path = [...object2.split("."), ...path];
  for (const member of path) {
    let select;
    if (typeof member == "string") {
      select = /^[A-Za-z0-9$_]+$/.test(member) ? t.identifier(member) : t.stringLiteral(member);
    } else if (typeof member == "number")
      select = t.numericLiteral(member);
    else
      throw new Error("Bad member id, only strings and numbers are allowed");
    object2 = typeof object2 == "object" ? t.memberExpression(object2, select, select.type !== "Identifier") : select;
  }
  return object2;
}
function call(callee, ...args) {
  return t.callExpression(callee, args);
}
function require2(from) {
  const argument = typeof from == "string" ? t.stringLiteral(from) : from;
  return t.callExpression(t.identifier("require"), [argument]);
}
function declare(type, id, init) {
  return t.variableDeclaration(type, [
    t.variableDeclarator(id, init)
  ]);
}
function objectAssign(...objects) {
  return t.callExpression(get("Object.assign"), objects);
}
function objectKeys(object2) {
  return call(get("Object.keys"), object2);
}
function template(text) {
  return t.templateLiteral([
    t.templateElement({raw: text, cooked: text}, true)
  ], []);
}
var COMPARE_OP = ["==", "===", "!==", "in", "instanceof", ">", "<", ">=", "<="];
function isBinaryAssertion(a) {
  if (t.isBinaryExpression(a)) {
    if (COMPARE_OP.includes(a.operator))
      return true;
  }
}

// src/utility.ts
var m32 = Math.imul;
function hash(str = "", length = 3) {
  const x = 2246822507, y = 3266489909;
  let h1 = 3735928559, h2 = 1103547991;
  for (let i = 0, ch; i < str.length; i++) {
    ch = str.charCodeAt(i);
    h1 = m32(h1 ^ ch, 2654435761);
    h2 = m32(h2 ^ ch, 1597334677);
  }
  h1 = m32(h1 ^ h1 >>> 16, x) ^ m32(h2 ^ h2 >>> 13, y);
  h2 = m32(h2 ^ h2 >>> 16, x) ^ m32(h1 ^ h1 >>> 13, y);
  const out = 4294967296 * (2097151 & h2) + (h1 >>> 0);
  return out.toString(32).substring(0, length);
}
function ensureArray(a) {
  return Array.isArray(a) ? a : [a];
}
var Stack = class {
  constructor() {
    this.layer = {};
  }
  stack() {
    return Object.assign(Object.create(this), {
      layer: Object.create(this.layer)
    });
  }
  set(key, value) {
    this.layer[key] = value;
  }
  get(key) {
    return this.layer[key];
  }
  has(key) {
    return this.layer.hasOwnProperty(key);
  }
};
var ArrayStack = class extends Array {
  insert(x) {
    if (Array.isArray(this.top))
      this.top.push(x);
    else {
      this.top = [x];
      super.push(this.top);
    }
  }
  push(x) {
    this.top = x;
    return super.push(x);
  }
};
function doUntilEmpty(startingData, step) {
  let i = 0;
  let queue = [startingData];
  do {
    let pending = [];
    const output = step(queue[i], (...next) => pending.push(...next));
    if (output !== void 0)
      return output;
    if (!pending.length)
      i++;
    else {
      queue = [...pending, ...queue.slice(i + 1)];
      i = 0;
    }
  } while (i in queue);
}

// src/generate/attributes.ts
function toExpression(value) {
  switch (typeof value) {
    case "string":
      return syntax_exports.stringLiteral(value);
    case "number":
      return syntax_exports.numericLiteral(value);
    case "boolean":
      return syntax_exports.booleanLiteral(value);
    case "object":
      if (value === null)
        return syntax_exports.nullLiteral();
      else
        return value;
    default:
      return syntax_exports.identifier("undefined");
  }
}
var AttributeStack = class extends ArrayStack {
  constructor() {
    super(...arguments);
    this.exists = new Set();
    this.invariant = new Set();
  }
  insert(item, inline_only) {
    const {name} = item;
    if (name === void 0) {
      this.top = item;
      this.push(item);
      return;
    }
    if (this.exists.has(name))
      return;
    this.exists.add(name);
    if (item.invariant && !inline_only)
      this.invariant.add(item);
    else
      super.insert(item);
  }
  flatten() {
    if (!this.length)
      return;
    if (this.length == 1 && this[0] instanceof ExplicitStyle)
      return this[0].expression;
    else {
      const chunks = [];
      for (const item of this)
        if (item instanceof ExplicitStyle)
          chunks.push(syntax_exports.spreadElement(item.expression));
        else
          chunks.push(...item.map((style) => syntax_exports.objectProperty(syntax_exports.stringLiteral(style.name), style.expression)));
      return syntax_exports.objectExpression(chunks);
    }
  }
};

// src/handle/object.ts
var AttributeBody = class {
  constructor(context) {
    this.sequence = [];
    this.statements = [];
    this.children = [];
    this.includes = new Set();
    context.push(this);
  }
  get uid() {
    return this.context.unique(this.name);
  }
  adopt(child) {
    const index = this.children.push(child);
    if ("context" in child)
      child.context.resolveFor(index);
    this.add(child);
  }
  add(item) {
    this.sequence.push(item);
  }
  uses(name) {
    this.context.apply(name, this);
  }
};

// src/handle/element.ts
var ElementInline = class extends AttributeBody {
  toExpression() {
    const {program} = this.context;
    const output = generateElement(this);
    if (this.tagName || this.sequence.length)
      return program.element(output, this.tagName);
    else
      return program.container(output);
  }
  use(mod) {
    for (const use of [mod, ...mod.includes]) {
      this.includes.add(use);
      use.targets.add(this);
    }
  }
};

// src/generate/element.ts
var byPriority = (x, y) => x.priority - y.priority;
function generateElement(element) {
  const {context, sequence, includes} = element;
  const inline_only = context.opts.styleMode === "inline";
  const no_collapse = context.opts.styleMode === "verbose";
  const props = [];
  const children = [];
  const style = new AttributeStack();
  const classList = new Set();
  Array.from(includes).sort(byPriority).forEach(applyModifier);
  sequence.forEach(apply);
  if (element instanceof ElementInline && style.invariant.size)
    element = new DefineLocal(element, style.invariant);
  if (element instanceof Define)
    useClass(element);
  const className = classValue(classList, context.program);
  const stylesProp = style.flatten();
  if (className)
    props.push({name: "className", value: className});
  if (stylesProp)
    props.push({name: "style", value: stylesProp});
  return {props, children};
  function apply(item) {
    if (item instanceof ExplicitStyle)
      style.insert(item, inline_only);
    else if (item instanceof Prop)
      applyProp(item);
    else if ("toExpression" in item) {
      const child = item.toExpression();
      if (child && !syntax_exports.isBooleanLiteral(child, {value: false}))
        children.push(child);
      if ("toClassName" in item) {
        const className2 = item.toClassName();
        if (className2)
          classList.add(className2);
      }
    } else if (syntax_exports.isExpression(item))
      children.push(item);
  }
  function applyProp(item) {
    const {name} = item;
    if (name === "style") {
      const styleProp = item.expression;
      const spread = new ExplicitStyle(false, styleProp);
      style.push(spread);
      return;
    }
    if (name === "className") {
      let {value} = item;
      if (value && typeof value == "object") {
        if (syntax_exports.isStringLiteral(value))
          ({value} = value);
        else if (syntax_exports.isExpression(value)) {
          classList.add(value);
          return;
        }
      }
      if (typeof value == "string")
        classList.add(value.trim());
      return;
    }
    props.push({name, value: item.expression});
  }
  function useClass(from) {
    if (inline_only || from.collapsable && !no_collapse)
      return false;
    from.setActive();
    if (from.isDeclared && from.isUsed)
      classList.add(from.uid);
    return true;
  }
  function applyModifier(mod) {
    if (inline_only && mod instanceof DefineVariant) {
      console.warn(`Cannot include CSS for ${mod.selector} with inline_only mode. Skipping.`);
      return;
    }
    const using_css = useClass(mod);
    for (const prop of mod.sequence)
      if (prop instanceof ExplicitStyle) {
        const {name, invariant} = prop;
        if (!name || invariant && using_css)
          continue;
        style.insert(prop);
      } else
        apply(prop);
  }
}
function classValue(list, program) {
  if (!list.size)
    return;
  const selectors = [];
  let className = "";
  for (const item of list)
    if (typeof item == "string")
      className += " " + item;
    else
      selectors.push(item);
  if (className)
    selectors.unshift(syntax_exports.stringLiteral(className.slice(1)));
  if (selectors.length > 1) {
    const _use = program.ensure("$runtime", "use");
    return syntax_exports.callExpression(_use, selectors);
  }
  return selectors[0];
}

// src/generate/es5.ts
function createElement(tag, properties = [], children = []) {
  const create = this.ensure("$pragma", "createElement", "create");
  if (!tag)
    tag = this.ensure("$pragma", "Fragment").name;
  const type = typeof tag === "string" ? /^[A-Z]/.test(tag) ? syntax_exports.identifier(tag) : syntax_exports.stringLiteral(tag) : stripJSX(tag);
  const props = recombineProps(properties);
  return syntax_exports.callExpression(create, [type, props, ...children]);
}
function recombineProps(props) {
  const propStack = new ArrayStack();
  if (props.length === 0)
    return object();
  for (const {name, value} of props)
    if (!name)
      propStack.push(value);
    else
      propStack.insert(syntax_exports.objectProperty(syntax_exports.stringLiteral(name), value));
  const properties = propStack.map((chunk) => Array.isArray(chunk) ? syntax_exports.objectExpression(chunk) : chunk);
  if (properties[0].type !== "ObjectExpression")
    properties.unshift(object());
  return properties.length > 1 ? objectAssign(...properties) : properties[0];
}
function stripJSX(exp) {
  switch (exp.type) {
    case "Identifier":
      return exp;
    case "JSXIdentifier":
      return syntax_exports.identifier(exp.name);
    case "JSXMemberExpression":
      return syntax_exports.memberExpression(stripJSX(exp.object), stripJSX(exp.property));
    default:
      throw new Error("Bad MemeberExpression");
  }
}

// src/handle/definition.ts
var Define = class extends AttributeBody {
  constructor() {
    super(...arguments);
    this.priority = 1;
    this.provides = new Set();
    this.dependant = new Set();
    this.targets = new Set();
  }
  provide(define) {
    this.provides.add(define);
  }
  toExpression(maybeProps) {
    const info = generateElement(this);
    if (maybeProps && info.children.length === 0)
      return recombineProps(info.props);
    return this.context.program.container(info);
  }
  get isUsed() {
    if (this.context.modifiersDeclared.has(this))
      return true;
    if (this.targets.size)
      return true;
    for (const child of this.dependant)
      if (child.isUsed)
        return true;
  }
  get isDeclared() {
    return doUntilEmpty(this, (x, add) => {
      if (x.containsStyle(true))
        return true;
      add(...x.dependant);
    });
  }
  get selector() {
    return [`.${this.uid}`];
  }
  get collapsable() {
    return this.targets.size == 1 && this.dependant.size < 1 && !this.onlyWithin;
  }
  containsStyle(arg) {
    return this.sequence.find((style) => {
      if (style instanceof ExplicitStyle) {
        if (typeof arg == "string")
          return arg == style.name;
        else
          return !arg || style.invariant;
      }
    });
  }
  setActive(withPriority) {
    if (!this.containsStyle(true))
      return;
    if (withPriority > this.priority)
      this.priority = withPriority;
    this.context.modifiersDeclared.add(this);
  }
  addStyle(name, value) {
    this.add(new ExplicitStyle(name, value));
  }
  use(mod) {
    this.includes.add(mod);
    if (mod instanceof DefineVariant)
      this.dependant.add(mod);
  }
};
var DefineLocal = class extends Define {
  constructor(parent, styles) {
    super(parent.context);
    this.parent = parent;
    this.sequence = Array.from(styles);
    this.priority = 2;
  }
  get uid() {
    return this.parent.uid;
  }
};
var DefineElement = class extends Define {
  constructor(context, name) {
    super(context);
    this.name = name;
    this.context.resolveFor(name);
  }
};
var DefineContainer = class extends DefineElement {
  provide(define) {
    this.context.elementMod(define);
  }
};
var DefineVariant = class extends Define {
  constructor(parent, suffix, priority) {
    super(parent.context);
    this.parent = parent;
    this.suffix = suffix;
    this.priority = priority;
  }
  get selector() {
    return [`.${this.parent.uid}${this.suffix}`];
  }
  get uid() {
    return this.parent.uid;
  }
  get collapsable() {
    return false;
  }
  provide(define) {
    define.onlyWithin = this;
    define.priority = this.priority;
    this.parent.provide(define);
    this.dependant.add(define);
  }
};

// src/generate/jsx.ts
var IsLegalAttribute = /^[a-zA-Z_][\w-]*$/;
function createElement2(tag, properties = [], content = []) {
  if (!tag)
    tag = this.ensure("$pragma", "Fragment").name;
  const type = typeof tag == "string" ? syntax_exports.jsxIdentifier(tag) : tag;
  const props = properties.map(createAttribute);
  const children = content.map(jsxContent);
  this.ensure("$pragma", "default", "React");
  const contains = children.length > 0;
  return syntax_exports.jsxElement(syntax_exports.jsxOpeningElement(type, props, !contains), contains ? syntax_exports.jsxClosingElement(type) : void 0, children);
}
function jsxContent(child) {
  if (syntax_exports.isJSXElement(child))
    return child;
  if (syntax_exports.isStringLiteral(child) && !/\{/.test(child.value))
    return syntax_exports.jsxText(child.value);
  return syntax_exports.jsxExpressionContainer(child);
}
function createAttribute({name, value}) {
  if (typeof name !== "string")
    return syntax_exports.jsxSpreadAttribute(value);
  if (IsLegalAttribute.test(name) == false)
    throw new Error(`Illegal characters in prop named ${name}`);
  return syntax_exports.jsxAttribute(syntax_exports.jsxIdentifier(name), syntax_exports.isStringLiteral(value) ? value.value === "true" ? null : value : syntax_exports.jsxExpressionContainer(value));
}

// src/scope.ts
var FileManager = class {
  constructor(path, context) {
    this.imports = {};
    this.importIndices = {};
    const create = context.opts.output === "js" ? createElement : createElement2;
    this.body = path.node.body;
    this.createElement = create.bind(this);
    this.opts = context.opts;
    this.scope = path.scope;
  }
  element(src, tagName) {
    const tag = tagName || "div";
    return this.createElement(tag, src.props, src.children);
  }
  container(src, key) {
    let {children} = src;
    if (src.props.length)
      children = [this.element(src)];
    if (children.length > 1 || key) {
      const props = key && [{name: "key", value: key}];
      return this.createElement(null, props, children);
    }
    return children[0] || syntax_exports.booleanLiteral(false);
  }
  replaceAlias(value) {
    if (value[0] !== "$")
      return value;
    const name = value.slice(1);
    return this.opts[name];
  }
  ensureUID(name = "temp") {
    const {scope} = this;
    let uid = name = name.replace(/^_+/, "").replace(/[0-9]+$/g, "");
    for (let i = 2; scope.hasBinding(uid) || scope.hasGlobal(uid) || scope.hasReference(uid); i++) {
      uid = name + i;
    }
    const program = scope.getProgramParent();
    program.references[uid] = true;
    program.uids[uid] = true;
    return uid;
  }
  ensureUIDIdentifier(name) {
    return syntax_exports.identifier(this.ensureUID(name));
  }
  close() {
    if (this.opts.externals === false)
      return;
    Object.entries(this.imports).forEach(([name, external]) => {
      if (external.exists)
        return;
      const importStatement = this.createImport(name);
      if (importStatement) {
        const index = this.importIndices[name];
        this.body.splice(index, 0, importStatement);
      }
    });
  }
};
var ImportManager = class extends FileManager {
  constructor() {
    super(...arguments);
    this.imports = {};
  }
  ensure(from, name, alt = name) {
    from = this.replaceAlias(from);
    let uid;
    const list = this.ensureImported(from).items;
    if (name == "default") {
      if (syntax_exports.isImportDefaultSpecifier(list[0]))
        return list[0].local;
      else {
        uid = this.ensureUIDIdentifier(alt);
        list.unshift(syntax_exports.importDefaultSpecifier(uid));
        return uid;
      }
    }
    for (const spec of list)
      if ("imported" in spec && syntax_exports.isIdentifier(spec.imported, {name})) {
        uid = syntax_exports.identifier(spec.local.name);
        break;
      }
    if (!uid) {
      uid = this.ensureUIDIdentifier(alt || name);
      list.push(syntax_exports.importSpecifier(uid, syntax_exports.identifier(name)));
    }
    return uid;
  }
  ensureImported(name) {
    const {imports} = this;
    name = this.replaceAlias(name);
    if (imports[name])
      return imports[name];
    for (const stat of this.body)
      if (syntax_exports.isImportDeclaration(stat) && stat.source.value == name)
        return imports[name] = {
          exists: true,
          items: stat.specifiers
        };
    return imports[name] = {
      exists: false,
      items: []
    };
  }
  createImport(name) {
    const list = this.imports[name].items;
    if (list.length)
      return syntax_exports.importDeclaration(list, syntax_exports.stringLiteral(name));
  }
};
var RequireManager = class extends FileManager {
  constructor() {
    super(...arguments);
    this.imports = {};
    this.importTargets = {};
  }
  ensure(from, name, alt = name) {
    const source = this.ensureImported(from).items;
    for (const {key: key2, value} of source)
      if (syntax_exports.isIdentifier(key2, {name}) && syntax_exports.isIdentifier(value))
        return value;
    const ref = this.ensureUIDIdentifier(alt);
    const key = syntax_exports.identifier(name);
    const useShorthand = ref.name === name;
    const property = syntax_exports.objectProperty(key, ref, false, useShorthand);
    source.push(property);
    return ref;
  }
  ensureImported(name) {
    const {body, imports, importTargets} = this;
    name = this.replaceAlias(name);
    if (name in imports)
      return imports[name];
    let target;
    let list;
    for (let i = 0, stat; stat = body[i]; i++)
      if (syntax_exports.isVariableDeclaration(stat))
        target = requireResultFrom(name, stat);
    if (target && syntax_exports.isObjectPattern(target))
      list = imports[name] = {
        exists: true,
        items: target.properties
      };
    else {
      list = imports[name] = {items: []};
      if (syntax_exports.isIdentifier(target))
        importTargets[name] = target;
    }
    return list;
  }
  createImport(name) {
    const list = this.imports[name].items;
    if (list.length) {
      const target = this.importTargets[name] || require2(name);
      return declare("const", syntax_exports.objectPattern(list), target);
    }
  }
};
function requireResultFrom(name, statement) {
  for (const {init, id} of statement.declarations)
    if (syntax_exports.isCallExpression(init) && syntax_exports.isIdentifier(init.callee, {name: "require"}) && syntax_exports.isStringLiteral(init.arguments[0], {value: name}))
      return id;
}

// src/context.ts
var StackFrame = class {
  constructor(path, state, options) {
    this.modifiersDeclared = new Set();
    this.styleRoot = {};
    this.current = {};
    this.modifiers = new Stack();
    this.handlers = new Stack();
    this.current = state;
    this.prefix = hash(state.filename);
    this.opts = options;
    const {externals, output} = options;
    const FileManager2 = externals == "require" ? RequireManager : externals == "import" ? ImportManager : output == "js" ? RequireManager : ImportManager;
    this.program = new FileManager2(path, this);
  }
  get parent() {
    return Object.getPrototypeOf(this);
  }
  including(modifiers) {
    let context = this;
    for (const imports of modifiers) {
      context = Object.create(context);
      for (const name in imports)
        context.handlers.set(name, imports[name]);
    }
    return context;
  }
  apply(name, target) {
    let modify = this.elementMod(name);
    while (modify) {
      target.use(modify);
      for (const sub of modify.provides)
        this.elementMod(sub);
      modify = modify.next;
    }
  }
  push(node) {
    const frame = Object.create(this);
    node.context = frame;
    frame.current = node;
    if (node instanceof DefineElement)
      frame.currentElement = node;
    frame.handlers = frame.handlers.stack();
    frame.modifiers = frame.modifiers.stack();
    return frame;
  }
  unique(name) {
    return name + "_" + hash(this.prefix);
  }
  resolveFor(append) {
    this.prefix = `${this.prefix} ${append || ""}`;
  }
  getHandler(named, ignoreOwn = false) {
    let context = this;
    if (ignoreOwn)
      for (let found; !found; ) {
        found = context.handlers.has(named);
        context = context.parent;
      }
    const [key, ...path] = named.split(".");
    let handler = this.handlers.get(key);
    for (const key2 of path)
      handler = handler[key2];
    return handler;
  }
  elementMod(mod) {
    const stack = this.modifiers;
    if (typeof mod == "string")
      return stack.get(mod);
    else {
      const name = mod.name;
      if (stack.get(name))
        mod.next = stack.get(name);
      stack.set(name, mod);
    }
  }
};

// src/errors.ts
var Status = {
  currentFile: void 0
};
function ParseErrors(register) {
  const Errors = {};
  for (const error in register) {
    const message = [];
    for (const segment of register[error].split(/\{(?=\d+\})/)) {
      const ammend = /(\d+)\}(.*)/.exec(segment);
      if (ammend)
        message.push(parseInt(ammend[1]), ammend[2]);
      else
        message.push(segment);
    }
    Errors[error] = (node, ...args) => {
      let quote = "";
      if ("node" in node)
        node = node.node;
      for (const slice of message)
        quote += typeof slice == "string" ? slice : args[slice - 1];
      return Status.currentFile.buildCodeFrameError(node, quote);
    };
  }
  return Errors;
}

// src/generate/styles.ts
function styleDeclaration(context, filename) {
  const {modifiersDeclared, program, opts} = context;
  const pretty = opts.printStyle == "pretty";
  const hot = opts.hot !== false;
  if (!modifiersDeclared.size)
    return;
  const runtime = program.ensure("$runtime", "default", "CSS");
  const mediaGroups = prioritize(modifiersDeclared);
  const printedStyle = serialize(mediaGroups, pretty);
  const args = [template(printedStyle)];
  if (hot) {
    const uid = hash(filename, 10);
    args.push(syntax_exports.stringLiteral(uid));
  }
  return syntax_exports.expressionStatement(syntax_exports.callExpression(get(runtime, "put"), args));
}
function prioritize(source) {
  const media = {
    default: []
  };
  for (let item of source) {
    const {priority = 0} = item;
    const query = "default";
    const selector = buildSelector(item);
    const styles = print(item);
    const targetQuery = query in media ? media[query] : media[query] = [];
    const group = priority in targetQuery ? targetQuery[priority] : targetQuery[priority] = [];
    group.push([selector, styles]);
  }
  return media;
}
function serialize(media, pretty) {
  const lines = [];
  for (const query in media) {
    media[query].forEach((bunch, index) => {
      if (!pretty)
        lines.push(`/* ${index} */`);
      for (const [name, styles] of bunch) {
        if (pretty) {
          const rules = styles.map((x) => `	${x};`);
          lines.push(name + " { ", ...rules, "}");
        } else {
          const block = styles.join("; ");
          lines.push(`${name} { ${block} }`);
        }
      }
    });
  }
  const content = lines.map((x) => "	" + x).join("\n");
  return `
${content}
`;
}
function buildSelector(target) {
  let selection = "";
  do {
    let select = target.selector.join("");
    if (selection)
      select += " " + selection;
    selection = select;
  } while (target = target.onlyWithin);
  return selection;
}
function print(target) {
  const items = [];
  for (const item of target.sequence)
    if (item instanceof ExplicitStyle && item.invariant)
      items.push(item);
  return items.map((style) => {
    let styleKey = style.name;
    if (typeof styleKey == "string")
      styleKey = styleKey.replace(/([A-Z]+)/g, "-$1").toLowerCase();
    const line = `${styleKey}: ${style.value}`;
    if (style.important)
      return `${line} !important`;
    return line;
  });
}

// src/modifier/forward.ts
function forwardProp(...propNames) {
  const target = this.target;
  const parent = target.context.currentComponent;
  if (!parent)
    throw new Error("No parent component found in hierarchy");
  const {exec} = parent;
  if (!exec)
    throw new Error("Can only apply props from a parent `() => do {}` function!");
  const {scope} = exec;
  const properties = getProps(parent, exec);
  for (const key of ["className", "style"])
    if (propNames.includes(key))
      target.add(new Prop(key, getFromProps(key)));
  if (propNames.includes("ref")) {
    const {program} = target.context;
    const _ref = uniqueWithin(scope, "ref");
    const _forwardRef = program.ensure("$pragma", "forwardRef");
    const _wrapped = call(_forwardRef, exec.node);
    exec.pushContainer("params", _ref);
    exec.replaceWith(_wrapped);
    target.add(new Prop("ref", _ref));
  }
  function getFromProps(name) {
    const _key = syntax_exports.identifier(name);
    const _local = uniqueWithin(scope, name);
    properties.unshift(syntax_exports.objectProperty(_key, _local, false, _local.name == name));
    return _local;
  }
}
function uniqueWithin(scope, name) {
  return scope.hasBinding(name) ? scope.generateUidIdentifier(name) : syntax_exports.identifier(name);
}
function getProps(target, exec) {
  const {node} = exec;
  let props = node.params[0];
  if (!syntax_exports.isObjectPattern(props)) {
    const existing = props;
    props = syntax_exports.objectPattern([]);
    if (!existing)
      node.params[0] = props;
    else if (syntax_exports.isIdentifier(existing)) {
      const {statements} = target;
      for (const s of statements) {
        if (!syntax_exports.isVariableDeclaration(s))
          break;
        for (const d of s.declarations)
          if (d.init && syntax_exports.isObjectPattern(d.id) && syntax_exports.isIdentifier(d.init, {name: existing.name}))
            return d.id.properties;
      }
      statements.unshift(declare("const", props, existing));
    }
  }
  return props.properties;
}

// src/modifier/builtIn.ts
function applyAlso(...names) {
  const {target} = this;
  for (const name of names)
    if (typeof name == "string") {
      const mod = target.context.elementMod(name);
      if (mod)
        target.use(mod);
    }
}
function setPriority(priority) {
  this.target.priority = priority;
}
var builtIn = {
  forward: forwardProp,
  priority: setPriority,
  use: applyAlso
};

// src/generate/iterate.ts
var Oops = ParseErrors({
  BadForOfAssignment: 'Assignment of variable left of "of" must be Identifier or Destruture',
  BadForInAssignment: "Left of ForInStatement must be an Identifier here!"
});
function forElement(node, define) {
  const {statements} = define;
  const {program} = define.context;
  const output = define.toExpression();
  if (!output)
    return;
  const accumulator = program.ensureUIDIdentifier("add");
  const collect = program.ensure("$runtime", "collect");
  let body = syntax_exports.expressionStatement(call(accumulator, output));
  if (statements.length)
    body = syntax_exports.blockStatement([...statements, body]);
  node.body = body;
  return call(collect, syntax_exports.arrowFunctionExpression([accumulator], syntax_exports.blockStatement([node])));
}
function forXElement(node, define) {
  let {left, right, key} = getReferences(node);
  key = ensureKeyProp(define, key);
  let body = define.toExpression();
  if (!body)
    return;
  if (define.statements.length)
    body = syntax_exports.blockStatement([
      ...define.statements,
      syntax_exports.returnStatement(body)
    ]);
  if (syntax_exports.isForOfStatement(node)) {
    const params = key ? [left, key] : [left];
    return call(get(right, "map"), syntax_exports.arrowFunctionExpression(params, body));
  } else
    return call(get(objectKeys(right), "map"), syntax_exports.arrowFunctionExpression([left], body));
}
function getReferences(node) {
  let {left, right} = node;
  let key;
  if (syntax_exports.isVariableDeclaration(left))
    left = left.declarations[0].id;
  if (syntax_exports.isIdentifier(left) || syntax_exports.isObjectPattern(left) || syntax_exports.isArrayPattern(left))
    void 0;
  else
    throw Oops.BadForOfAssignment(left);
  if (syntax_exports.isBinaryExpression(right, {operator: "in"})) {
    key = right.left;
    right = right.right;
  }
  if (syntax_exports.isForInStatement(node))
    if (syntax_exports.isIdentifier(left))
      key = left;
    else
      throw Oops.BadForInAssignment(left);
  return {left, right, key};
}
function ensureKeyProp(from, used) {
  let {sequence, children} = from;
  const props = sequence.filter((x) => x instanceof Prop);
  for (const x of props)
    if (x.name === "key")
      return;
  if (children.length == 1 && props.length == 0) {
    const element = children[0];
    if (element instanceof ElementInline) {
      for (const x of element.sequence)
        if (x instanceof Prop && x.name === "key")
          return;
      sequence = element.sequence;
    }
  }
  if (!used)
    used = from.context.program.ensureUIDIdentifier("i");
  sequence.push(new Prop("key", used));
  return used;
}

// src/handle/iterate.ts
var ComponentFor = class {
  constructor(path, parent) {
    const name = path.type.replace("Statement", "Loop");
    const element = new DefineElement(parent.context, name);
    parse(element, path, "body");
    this.definition = element;
    this.node = path.node;
    parent.adopt(this);
  }
  toExpression() {
    const {node, definition} = this;
    return syntax_exports.isForStatement(node) ? forElement(node, definition) : forXElement(node, definition);
  }
};

// src/generate/switch.ts
var opt = syntax_exports.conditionalExpression;
var not = (a) => syntax_exports.unaryExpression("!", a);
var and = (a, b) => syntax_exports.logicalExpression("&&", a, b);
var anti = (a) => syntax_exports.isUnaryExpression(a, {operator: "!"}) ? a.argument : not(a);
var is = (a) => syntax_exports.isUnaryExpression(a, {operator: "!"}) || isBinaryAssertion(a) ? a : not(not(a));
function reduceToExpression(forks, predicate) {
  forks = forks.slice().reverse();
  let sum;
  for (const cond of forks) {
    const test = cond.test;
    const product = predicate(cond);
    if (sum && test)
      sum = product ? opt(test, product, sum) : and(anti(test), sum);
    else if (product)
      sum = test ? and(is(test), product) : product;
  }
  return sum;
}
function specifyOption(test) {
  if (!test)
    return "else";
  let ref = "if_";
  if (syntax_exports.isUnaryExpression(test, {operator: "!"})) {
    test = test.argument;
    ref = "not_";
  }
  if (syntax_exports.isIdentifier(test))
    return ref + test.name;
}

// src/handle/switch.ts
var ComponentIf = class {
  constructor(test) {
    this.test = test;
    this.forks = [];
  }
  toExpression() {
    return reduceToExpression(this.forks, (cond) => {
      let product;
      if (cond instanceof ComponentIf || cond.children.length)
        product = cond.toExpression();
      return product;
    });
  }
  toClassName() {
    return reduceToExpression(this.forks, (cond) => {
      if (cond instanceof ComponentIf)
        return cond.toClassName();
      const className = cond.toClassName();
      if (className)
        return syntax_exports.stringLiteral(className);
    });
  }
  setup(context, path) {
    const {forks} = this;
    let layer = path;
    while (true) {
      let consequent = layer.get("consequent");
      let test;
      if (layer.isIfStatement())
        test = layer.node.test;
      if (consequent.isBlockStatement()) {
        const inner = ensureArray(consequent.get("body"));
        if (inner.length == 1)
          consequent = inner[0];
      }
      const fork = consequent.isIfStatement() ? new ComponentIf(test) : new DefineConsequent(consequent, context, forks.length, test);
      forks.push(fork);
      layer = layer.get("alternate");
      if (layer.type === void 0)
        break;
      if (layer.type !== "IfStatement") {
        forks.push(new DefineConsequent(layer, context, forks.length));
        break;
      }
    }
  }
};
var DefineConsequent = class extends Define {
  constructor(consequent, context, index, test) {
    super(context);
    this.test = test;
    this.context.resolveFor(index);
    this.name = specifyOption(test) || `opt${index + 1}`;
    let parent = context.currentElement;
    if (parent instanceof DefineConsequent)
      parent = parent.anchor;
    parent.dependant.add(this);
    this.anchor = parent;
    this.priority = 5;
    parse(this, consequent);
  }
  get selector() {
    let parent = this.context.currentElement;
    return [...parent.selector, `.${this.uid}`];
  }
  get isDeclared() {
    return false;
  }
  toClassName() {
    const segments = [];
    for (const mod of [this, ...this.includes]) {
      mod.setActive(this.priority);
      if (mod.isUsed)
        segments.push(mod.uid);
    }
    return segments.join(" ");
  }
  provide(define) {
    define.onlyWithin = this;
    define.priority = 4;
    this.anchor.provide(define);
    this.dependant.add(define);
  }
};

// src/parse/jsx.ts
var Oops2 = ParseErrors({
  InvalidPropValue: "Can only consume an expression or string literal as value here.",
  UnhandledChild: "Can't parse JSX child of type {1}",
  JSXMemberExpression: "Member Expression is not supported!",
  NonJSXIdentifier: "Cannot handle non-identifier!"
});
var COMMON_HTML = [
  "article",
  "blockquote",
  "input",
  "h1",
  "h2",
  "h3",
  "h4",
  "h5",
  "h6",
  "p",
  "a",
  "ul",
  "ol",
  "li",
  "i",
  "b",
  "em",
  "strong",
  "span",
  "hr",
  "img",
  "div",
  "br"
];
function addElementFromJSX(path, parent) {
  let target = parent;
  const tag = path.get("openingElement").get("name");
  if (!tag.isJSXIdentifier({name: "this"})) {
    const child = createElement3(tag.node, target);
    target.adopt(child);
    target = child;
  }
  const queue = [[target, path]];
  for (const [element, path2] of queue) {
    const children = path2.get("children");
    const attributes = path2.get("openingElement").get("attributes");
    for (const attribute of attributes)
      applyAttribute(element, attribute);
    children.forEach((path3, index) => {
      if (path3.isJSXElement()) {
        const child = createElement3(path3.node.openingElement.name, element);
        element.adopt(child);
        queue.push([child, path3]);
      } else if (path3.isJSXText()) {
        const {value} = path3.node;
        if (/^\n+ *$/.test(value))
          return;
        let text = value.replace(/ +/g, " ").replace(/\n\s*/, "");
        if (!index)
          text = text.trimLeft();
        if (index == children.length - 1)
          text = text.trimRight();
        element.adopt(syntax_exports.stringLiteral(text));
      } else if (path3.isJSXExpressionContainer())
        element.adopt(path3.node.expression);
      else
        Oops2.UnhandledChild(path3, path3.type);
    });
  }
}
function createElement3(tag, parent) {
  const target = new ElementInline(parent.context);
  let name;
  if (syntax_exports.isJSXMemberExpression(tag)) {
    name = tag.property.name;
    target.tagName = tag;
  } else if (syntax_exports.isJSXIdentifier(tag)) {
    name = tag.name;
    if (name == "s")
      name = "span";
    let explicit = /^[A-Z]/.test(name) || COMMON_HTML.includes(name);
    if (/^html-.+/.test(name)) {
      name = name.slice(5);
      explicit = true;
    }
    if (explicit || /^[A-Z]/.test(name))
      target.tagName = name;
  } else
    throw Oops2.NonJSXIdentifier(tag);
  target.name = name;
  target.uses(name);
  return target;
}
function applyAttribute(parent, attr) {
  let name;
  let value;
  if (attr.isJSXSpreadAttribute()) {
    const arg = attr.get("argument");
    if (arg.isDoExpression()) {
      const define = new DefineElement(parent.context, parent.name);
      parent.use(define);
      parse(define, arg, "body");
      return;
    }
    name = false;
    value = arg.node;
  } else {
    const expression = attr.node.value;
    name = attr.node.name.name;
    if (expression === null) {
      parent.uses(name);
      return;
    }
    switch (expression.type) {
      case "JSXExpressionContainer":
        value = expression.expression;
        break;
      case "StringLiteral":
        if (name == "src" && /^\.\//.test(expression.value))
          value = require2(expression.value);
        else
          value = expression;
        break;
      default:
        throw Oops2.InvalidPropValue(expression);
    }
  }
  parent.add(new Prop(name, value || null));
}

// src/parse/arguments.ts
var Oops3 = ParseErrors({
  UnaryUseless: "Unary operator here doesn't do anything",
  HexNoNegative: `Hexadecimal numbers are converted into colors (#FFF) so negative sign doesn't mean anything here.
Parenthesize the number if you really need "-{1}" for some reason...`,
  ArrowNotImplemented: "Arrow Function not supported yet",
  ArgumentSpread: "Cannot parse argument spreads for modifier handlers",
  UnknownArgument: "Unknown argument while parsing for modifier.",
  MustBeIdentifier: "Only Identifers allowed here! Call expression must reference another modifier.",
  ModiferCantParse: "Illegal value in modifier",
  ElseNotSupported: "An else statement in an if modifier is not yet supported"
});
var DelegateTypes = class {
  parse(element) {
    if (syntax_exports.isExpressionStatement(element))
      element = element.expression;
    return [].concat(syntax_exports.isExpression(element) ? this.Expression(element) : this.Extract(element));
  }
  Expression(element, childKey) {
    if (childKey)
      element = element[childKey];
    if (inParenthesis(element))
      return element;
    return this.Extract(element);
  }
  Extract(element) {
    if (element.type in this)
      return this[element.type](element);
    else
      throw Oops3.UnknownArgument(element);
  }
  Identifier(e) {
    return e.name;
  }
  StringLiteral(e) {
    return e.value;
  }
  TemplateLiteral(e) {
    const {quasis} = e;
    if (quasis.length > 1)
      return e;
    return e.quasis[0].value;
  }
  UnaryExpression(e) {
    const arg = e.argument;
    if (e.operator == "-" && syntax_exports.isNumericLiteral(arg))
      return this.NumericLiteral(arg, -1);
    if (e.operator == "!" && syntax_exports.isIdentifier(arg) && arg.name == "important")
      return "!important";
    else
      throw Oops3.UnaryUseless(e);
  }
  BooleanLiteral(bool) {
    return bool.value;
  }
  NumericLiteral(number, sign = 1) {
    const {extra: {rawValue, raw}} = number;
    if (inParenthesis(number) || !/^0x/.test(raw)) {
      if (raw.indexOf(".") > 0)
        return sign == -1 ? "-" + raw : raw;
      return sign * rawValue;
    } else {
      if (sign == -1)
        throw Oops3.HexNoNegative(number, rawValue);
      return HEXColor(raw);
    }
  }
  NullLiteral() {
    return null;
  }
  BinaryExpression(binary) {
    const {left, right, operator} = binary;
    if (operator == "-" && left.type == "Identifier" && right.type == "Identifier" && right.start == left.end + 1)
      return left.name + "-" + right.name;
    else
      return [
        operator,
        this.Expression(binary, "left"),
        this.Expression(binary, "right")
      ];
  }
  SequenceExpression(sequence) {
    return sequence.expressions.map((x) => this.Expression(x));
  }
  CallExpression(e) {
    const callee = e.callee;
    const args = [];
    for (const item of e.arguments) {
      if (syntax_exports.isExpression(item))
        args.push(item);
      else if (syntax_exports.isSpreadElement(item))
        throw Oops3.ArgumentSpread(item);
      else
        throw Oops3.UnknownArgument(item);
    }
    if (!syntax_exports.isIdentifier(callee))
      throw Oops3.MustBeIdentifier(callee);
    const call2 = args.map((x) => this.Expression(x));
    call2.callee = callee.name;
    return call2;
  }
  ArrowFunctionExpression(e) {
    throw Oops3.ArrowNotImplemented(e);
  }
  IfStatement(statement) {
    const alt = statement.alternate;
    const test = statement.test;
    const body = statement.consequent;
    const data = {
      test: this.Expression(test)
    };
    if (alt)
      throw Oops3.ElseNotSupported(test);
    if (syntax_exports.isBlockStatement(body) || syntax_exports.isLabeledStatement(body) || syntax_exports.isExpressionStatement(body)) {
      Object.assign(data, this.Extract(body));
    }
    return data;
  }
  LabeledStatement(statement) {
    return {
      [statement.label.name]: this.parse(statement.body)
    };
  }
  BlockStatement(statement) {
    const map = {};
    for (const item of statement.body) {
      if (!syntax_exports.isLabeledStatement(item))
        throw Oops3.ModiferCantParse(statement);
      map[item.label.name] = this.parse(item.body);
    }
    return map;
  }
};
function HEXColor(raw) {
  raw = raw.substring(2);
  if (raw.length == 1)
    raw = "000" + raw;
  else if (raw.length == 2)
    raw = "000000" + raw;
  if (raw.length % 4 == 0) {
    let decimal = [];
    if (raw.length == 4)
      decimal = Array.from(raw).map((x) => parseInt(x + x, 16));
    else
      for (let i = 0; i < 4; i++)
        decimal.push(parseInt(raw.slice(i * 2, i * 2 + 2), 16));
    decimal[3] = (decimal[3] / 255).toFixed(3);
    return `rgba(${decimal.join(",")})`;
  } else
    return "#" + raw;
}
function inParenthesis(node) {
  const {extra} = node;
  return extra ? extra.parenthesized === true : false;
}

// src/parse/modifiers.ts
var Oops4 = ParseErrors({
  InlineModeNoVariants: "Cannot attach a CSS variant while styleMode is set to inline."
});
var ModifyDelegate = class {
  constructor(target, name, transform, input) {
    this.target = target;
    this.name = name;
    this.attrs = {};
    this.styles = {};
    this.props = {};
    let important = false;
    let args;
    if (Array.isArray(input))
      args = input;
    else {
      args = new DelegateTypes().parse(input.node);
      this.body = input;
    }
    if (args[args.length - 1] == "!important") {
      important = true;
      args.pop();
    }
    this.options = target.context.opts;
    this.arguments = args;
    if (!transform)
      transform = propertyModifierDefault;
    const output = transform.apply(this, args);
    if (!output || this.done)
      return;
    const {attrs, style} = output;
    if (style)
      for (const name2 in style)
        this.styles[name2] = new ExplicitStyle(name2, style[name2], important);
    if (attrs)
      for (const name2 in attrs) {
        let args2 = attrs[name2];
        if (!Array.isArray(args2))
          args2 = [args2];
        if (important)
          args2.push("!important");
        this.attrs[name2] = args2;
      }
  }
  setContingent(contingent, priority, usingBody) {
    const body = usingBody || this.body;
    if (this.options.styleMode == "inline")
      throw Oops4.InlineModeNoVariants(body.parentPath);
    const mod = new DefineVariant(this.target, contingent, priority);
    parse(mod, body);
    this.target.use(mod);
    return mod;
  }
};
function propertyModifierDefault() {
  const args = this.arguments.map((arg) => arg.value || arg.requires ? require2(arg.requires) : arg);
  const output = args.length == 1 || typeof args[0] == "object" ? args[0] : Array.from(args).join(" ");
  return {
    style: {
      [this.name]: output
    }
  };
}

// src/parse/labels.ts
var Oops5 = ParseErrors({
  BadInputModifier: "Modifier input of type {1} not supported here!",
  BadModifierName: "Modifier name cannot start with _ symbol!",
  DuplicateModifier: "Duplicate declaration of named modifier!",
  IllegalAtTopLevel: "Cannot apply element styles in top-level of program"
});
var LeadingDollarSign = /^\$[a-z]\w*/;
function handleTopLevelDefine(node, context) {
  const {name} = node.get("label").node;
  const body = node.get("body");
  if (name[0] == "_")
    throw Oops5.BadModifierName(node);
  if (context.modifiers.has(name))
    throw Oops5.DuplicateModifier(node);
  if (body.isExpressionStatement())
    throw Oops5.IllegalAtTopLevel(node);
  const define = new DefineElement(context, name);
  parse(define, body);
  context.elementMod(define);
}
function handleDefine(target, path) {
  let key = path.node.label.name;
  let body = path.get("body");
  if (key[0] == "_")
    throw Oops5.BadModifierName(path);
  if (body.isExpressionStatement() || body.isLabeledStatement() || LeadingDollarSign.test(key)) {
    while (body.isLabeledStatement()) {
      key = `${key}.${body.node.label.name}`;
      body = body.get("body");
    }
    handleDirective(key, target, body);
  } else if (body.isBlockStatement() || body.isLabeledStatement())
    handleNestedDefine(target, key, body);
  else
    throw Oops5.BadInputModifier(body, body.type);
}
function handleNestedDefine(target, name, body) {
  const mod = new DefineElement(target.context, name);
  if (/^[A-Z]/.test(name))
    mod.priority = 3;
  target.provide(mod);
  parse(mod, body);
}
function handleDirective(name, recipient, input) {
  const {context} = recipient;
  const handler = context.getHandler(name);
  const output = {};
  const initial = [name, handler, input];
  doUntilEmpty(initial, (next, enqueue) => {
    const {styles, attrs} = new ModifyDelegate(recipient, ...next);
    Object.assign(output, styles);
    Object.entries(attrs).forEach(([key, value]) => {
      if (!value)
        return;
      const useNext = key === name;
      const handler2 = context.getHandler(key, useNext);
      enqueue([key, handler2, value]);
    });
  });
  for (const name2 in output)
    recipient.add(output[name2]);
}

// src/parse/body.ts
var Oops6 = ParseErrors({
  PropNotIdentifier: "Assignment must be identifier name of a prop."
});
function parse(target, ast, key) {
  if (key)
    ast = ast.get(key);
  const content = ast.isBlockStatement() ? ensureArray(ast.get("body")) : [ast];
  for (let item of content)
    parseContent(target, item);
}
function parseContent(target, path) {
  if (path.isLabeledStatement()) {
    handleDefine(target, path);
    return;
  }
  if (path.isIfStatement()) {
    const item = new ComponentIf();
    item.setup(target.context, path);
    target.adopt(item);
    return;
  }
  if (path.isForXStatement()) {
    new ComponentFor(path, target);
    return;
  }
  if (path.isForStatement()) {
    new ComponentFor(path, target);
    return;
  }
  if (path.isExpressionStatement()) {
    const e = path.get("expression");
    if (e.isJSXElement()) {
      addElementFromJSX(e, target);
      return;
    }
    if (e.isAssignmentExpression({operator: "="})) {
      const {left, right} = e.node;
      if (!syntax_exports.isIdentifier(left))
        throw Oops6.PropNotIdentifier(left);
      const prop = new Prop(left.name, right);
      target.add(prop);
      return;
    }
  }
  target.statements.push(path.node);
}

// src/parse/entry.ts
function generateEntryElement(path, context) {
  const exec = parentFunction(path);
  const name = containerName(exec || path);
  const define = new DefineContainer(context, name);
  define.context.currentComponent = define;
  define.exec = exec;
  if (/^[A-Z]/.test(name))
    define.uses(name);
  parse(define, path.get("body"));
  return define;
}
function parentFunction(path) {
  const parent = path.parentPath;
  let containerFn;
  if (parent.isArrowFunctionExpression())
    containerFn = parent;
  else if (parent.isReturnStatement()) {
    const container = parent.findParent((x) => /.*Function.*/.test(x.type));
    if (container && container.type == "ArrowFunctionExpression")
      containerFn = container;
  }
  return containerFn;
}
function containerName(path) {
  let parent = path.parentPath;
  let encounteredReturn;
  while (true)
    switch (parent.type) {
      case "VariableDeclarator": {
        const {id} = parent.node;
        return syntax_exports.isIdentifier(id) ? id.name : parent.parentPath.node.kind;
      }
      case "AssignmentExpression":
      case "AssignmentPattern": {
        const {left} = parent.node;
        return syntax_exports.isIdentifier(left) ? left.name : "assignment";
      }
      case "FunctionDeclaration":
        return path.node.id.name;
      case "ExportDefaultDeclaration":
        return "defaultExport";
      case "ArrowFunctionExpression": {
        parent = parent.parentPath;
        continue;
      }
      case "ReturnStatement": {
        if (encounteredReturn)
          return "return";
        encounteredReturn = path;
        const ancestry = path.getAncestry();
        const within = ancestry.find((x) => x.isFunction());
        if (!within)
          throw new Error("wat");
        const {node} = within;
        if ("id" in node && node.id)
          return node.id.name;
        if (node.type == "ObjectMethod") {
          parent = within.getAncestry()[2];
          continue;
        }
        if (node.type == "ClassMethod") {
          if (!syntax_exports.isIdentifier(node.key))
            return "ClassMethod";
          if (node.key.name == "render") {
            const owner = within.parentPath.parentPath;
            if (owner.node.id)
              return owner.node.id.name;
            else {
              parent = owner.parentPath;
              continue;
            }
          } else
            return node.key.name;
        }
        parent = within.parentPath;
        continue;
      }
      case "ObjectProperty": {
        const {key} = parent.node;
        return syntax_exports.isIdentifier(key) ? key.name : syntax_exports.isStringLiteral(key) ? key.value : "property";
      }
      default:
        return "element";
    }
}

// src/index.ts
var DEFAULT_OPTIONS = {
  env: "web",
  styleMode: "compile",
  runtime: "@expressive/css",
  pragma: "react",
  output: "js",
  modifiers: []
};
var src_default = () => ({
  manipulateOptions: (options, parse2) => {
    parse2.plugins.push("doExpressions", "jsx");
  },
  visitor: {
    Program: HandleProgram,
    DoExpression: HandleDoExpression
  }
});
var HandleProgram = {
  enter(path, state) {
    const options = __objSpread(__objSpread({}, DEFAULT_OPTIONS), state.opts);
    const external = Object.assign({}, ...options.modifiers);
    const context = state.context = new StackFrame(path, state, options).including([builtIn, external]);
    Status.currentFile = state.file;
    for (const item of path.get("body"))
      if (item.isLabeledStatement()) {
        handleTopLevelDefine(item, context);
        item.remove();
      }
  },
  exit(path, {filename, context}) {
    const styleBlock = styleDeclaration(context, filename);
    if (styleBlock)
      path.pushContainer("body", [styleBlock]);
    context.program.close();
  }
};
var HandleDoExpression = {
  enter(path, state) {
    let element = generateEntryElement(path, state.context);
    const collapsible = !element.exec;
    let output = element.toExpression(collapsible) || syntax_exports.booleanLiteral(false);
    if (element.exec && element.statements.length) {
      const body = [
        ...element.statements,
        syntax_exports.returnStatement(output)
      ];
      if (path.parentPath.isReturnStatement()) {
        path.parentPath.replaceWithMultiple(body);
        return;
      }
      output = syntax_exports.blockStatement(body);
    }
    path.replaceWith(output);
  }
};
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {});
